#ifndef SIDEBARMANAGER_H_
#define SIDEBARMANAGER_H_

#include <gtk/gtk.h>
#include "Sidebar.h"
#include "SidebarToolbox.h"
#include "SidebarView.h"
#include "SidebarAdd.h"
#include "EditManager.h"
#include "ToolSelector.h"
#include "ToolAddPolygon.h"


class SidebarManager {
  private:
    GtkWidget *sidebar, *scrolledWindow, *viewport;
    
    SidebarToolbox sidebarToolbox;
    
    SidebarView sidebarView;
    SidebarAdd sidebarAdd;
    
    Sidebar *activeSidebar;
    
    EditManager *editor;
    
    ToolAddPolygon toolAddPolygon;
    
    // prevent shallow copy
    SidebarManager(const SidebarManager &w);
    const SidebarManager& operator=(const SidebarManager &w);
    
  public:
    SidebarManager(EditManager *editor);
    virtual ~SidebarManager();
    
    GtkWidget *getWidget() {
      return sidebar;
    }
    
    void update();
};

#endif /*SIDEBARMANAGER_H_*/
